import sys

args = sys.argv[1:]
input_sentences_file = args[0]
relation = args[1]

def sublist_index(needle, haystack):
    for idx in range(len(haystack)):
        if needle == haystack[idx:len(needle)+idx]:
            return idx
    return -1

# for rel in p101 p1056 p106 p121 p1313 p1344 p166 p172 p39 p452 p509_p1196 p53 p607 p800 p865; do for suffix in dev test train; do python3 distant_supervision/ds_sentences_to_candidates.py ~/data/wikidata_tuples/contexts/$rel.tsv_$suffix $rel > ~/data/wikidata_tuples/contexts_candidates/$rel.tsv_$suffix; done; done

with open(input_sentences_file) as f:
    for line in f:
        parts = line.strip().split("\t")
        tokens = parts[0]
        query = parts[1]
        answer = parts[2]
        if (answer in query) or (query in answer):
            continue

        token_list = tokens.split(" ")
        query_list = query.split(" ")
        answer_list = answer.split(" ")

        query_start = sublist_index(query_list, token_list)
        answer_start = sublist_index(answer_list, token_list)
        if query_start == -1 or answer_start == -1:
            continue
        query_end = query_start + len(query_list)
        answer_end = answer_start + len(answer_list)

        s = "%s\t%s\t%s\t%s\t%d\t%d\t%d\t%d\t%s" % (query, relation, answer, "DUMMY", query_start, query_end, answer_start, answer_end, tokens)
        print(s)
