from elasticsearch import Elasticsearch


def results(es, es_index, query_str):
    """Return results for query_str in es_index"""
    # TODO
    return es.search(index=es_index, body={"query": {
        "query_string" : {
            "default_field" : "text",
            "query" : query_str# "\"" + query_str + "\""
        }
    }})


def hit_title(hit):
    """Return title of hit"""
    # TODO
    return hit["_source"]["title"]


def hit_text(hit):
    """Return text of hit"""
    # TODO
    return hit["_source"]["text"]


def context(needle, haystack, window=50, highlight_leftright=("","")):
    start = haystack.lower().find(needle.lower())
    if -1 == start:
        return haystack
    end = start + len(needle)
    left = haystack[start-window:start]
    middle = highlight_leftright[0] + haystack[start: end] + highlight_leftright[1]
    right = haystack[end:end+window]
    return left + middle + right


def main():

    es = Elasticsearch()
    while True:
        query_str = input("Query: ").strip()
        if not query_str:
            break
        res = results(es, 'wiki-sentences', query_str)
        print("Got %d Hits:" % res['hits']['total'])
        for hit in res['hits']['hits']:
            title = hit_title(hit)
            text = hit_text(hit)
            print("Article: " + title)
            print("..." + context(needle=query_str, haystack=text, highlight_leftright = ("[","]")).replace("\n", " ") + "...")
            print()

# lib/elasticsearch-5.2.1/bin/elasticsearch
if __name__ == "__main__":
    main()
